

function initCarousel() {
	$('.carousel').carousel({
	  interval: false,
	  wrap: false
	});

	addCarouselControlsListener();
}


var ignoreMove = false;
function addCarouselControlsListener() {
	$('.carousel').on('slid.bs.carousel', function (e) {
		if (ignoreMove) return;
		if (e.direction == "left") { // avanti
			moveForward();
		} else if (e.direction == "right") { // indietro
			moveBackward();
		}
	});

	$('.carousel').on('slide.bs.carousel', function (e) {
		if (!isFrontSide) {
			$(".carousel-item.active").next(".carousel-item").find(".flippable").flip({speed: 1});
			$(".carousel-item.active").next(".carousel-item").find(".flippable").flip(false);
			$(".carousel-item.active").next(".carousel-item").find(".flippable").flip({speed: 500});

			$(".carousel-item.active").prev(".carousel-item").find(".flippable").flip({speed: 1});
			$(".carousel-item.active").prev(".carousel-item").find(".flippable").flip(false);
			$(".carousel-item.active").prev(".carousel-item").find(".flippable").flip({speed: 500});
		}
	});

    $( "#imgNext2" ).click(function() {
        goBackHome();
    });
    $( "#imgNext" ).click(function() {
        goBackHome();
    });
    $( "#imgNextSmall" ).click(function() {
        goBackHome();
    });


}

function goBackHome() {
    if ( $( "#imgNext2" ).attr("src") != "img/btn-refresh-home.png" ) {
        //console.info("not go back home. " + $( "#imgNext2" ).attr("src"));
        return;
    }
    $( ".carousel-control-next" ).attr("href", "#");
    $( "#imgNextSmallHref" ).attr("href", "#");
    ignoreMove = true;
    $( ".carousel" ).removeClass( "slide" ); // tolgo l'animazione
    $('.carousel').carousel(0);
    $( ".carousel" ).addClass( "slide" ); // rimetto l'animazione
    ignoreMove = false;
    setTimeout(function(){
        $( "#imgNextHref" ).attr("href", "#doubleColCarousel");
        $( "#imgNext2Href" ).attr("href", "#oneColCarousel");
        $( "#imgNextSmallHref" ).attr("href", "#mobileCarousel");
    }, 600);
    currentIndex = 0;
    $('#bottomNumbers').text( (currentIndex+1) + " di " + slidesCounter );
    var percentage = 100 * ( (currentIndex+1) /slidesCounter ) + "%";
    $( "#progressBar" ).css( "width", percentage );

    $(".flippable").flip(false); // imposto la slide su front
    isFrontSide = true;
    stopTimer();
    stopAllMedia();


    $('#imgBack').attr("src","img/btn-back-disabled.png");
    $('#imgBack2').attr("src","img/btn-back-disabled.png");
    $('#imgBackSmall').attr("src","img/btn-back-disabled-small.png");
    $('#imgNext').attr("src","img/btn-next-enabled.png");
    $('#imgNext2').attr("src","img/btn-next-enabled.png");
    $('#imgNextSmall').attr("src","img/btn-next-enabled-small.png");

    if (doubleViewIsActive) {
        $( "#block2" ).addClass( "d-sm-none d-md-flex" );
        $( "#block1" ).removeClass( "d-sm-none d-md-flex" );
        doubleViewIsActive = !doubleViewIsActive;
    }

    $(".icon-expand").hide();
    $( ".btn-timer" ).removeClass( "d-flex" ).addClass( "d-none" );
}

function onChangedSlide() {
	moveCarouselToSlide(currentIndex); // mando tutti i carousel a quell'index
	$(".flippable").flip(false); // imposto la slide su front
	isFrontSide = true;
	stopTimer();

	if (config_data.pauseOnMedia) stopAllMedia();

	if (config_data.autoStart) startTimer();

	if (currentIndex == 0) {
		$(".icon-expand").hide();
		$( ".btn-timer" ).removeClass( "d-flex" ).addClass( "d-none" );
		if ( slidesFirstBundle.length>0 ) {
			if ( slidesFirstBundle[0].consegnaCard != "") $("#bundle-title").html("&nbsp;");
		}

		if (doubleViewIsActive) {
			$( "#block2" ).addClass( "d-sm-none d-md-flex" );
			$( "#block1" ).removeClass( "d-sm-none d-md-flex" );
			doubleViewIsActive = !doubleViewIsActive;
		}

	} else {
		$(".btn-timer" ).removeClass( "d-none" ).addClass( "d-flex" );
		$(".icon-expand").show();
		if ( slidesFirstBundle.length>0 ) {
            if ( slidesFirstBundle[currentIndex-1].consegnaCard != "") $("#bundle-title").html( slidesFirstBundle[currentIndex-1].consegnaCard );
            else $("#bundle-title").html("&nbsp;");
        }

	}
}


function moveForward() {

	if (currentIndex < (slidesCounter-1)) {
		currentIndex++;
		//console.debug("currentIndex.. " + currentIndex);
		$('#bottomNumbers').text( (currentIndex+1) + " di " + slidesCounter );
		var percentage = 100 * ( (currentIndex+1) /slidesCounter ) + "%";
		$( "#progressBar" ).css( "width", percentage );

        $('#imgBack').attr("src","img/btn-back-enabled.png");
		$('#imgBack2').attr("src","img/btn-back-enabled.png");
		$('#imgBackSmall').attr("src","img/btn-back-enabled-small.png");
        
		if (currentIndex >= (slidesCounter-1)) {
			$('#imgNext').attr("src","img/btn-refresh-home.png");
			$('#imgNext2').attr("src","img/btn-refresh-home.png");
            $('#imgNextSmall').attr("src","img/btn-refresh-home-small.png");          
		}
		onChangedSlide();
	}
}
function moveBackward() {
	if (currentIndex > 0) {
		currentIndex--;
		//console.debug("currentIndex.. " + currentIndex);
		$('#bottomNumbers').text( (currentIndex+1) + " di " + slidesCounter );
		var percentage = 100 * ( (currentIndex+1) /slidesCounter ) + "%";
		$( "#progressBar" ).css( "width", percentage );

		$('#imgNext').attr("src","img/btn-next-enabled.png");
		$('#imgNext2').attr("src","img/btn-next-enabled.png");
		$('#imgNextSmall').attr("src","img/btn-next-enabled-small.png");

		if (currentIndex <= 1) {
			$('#imgBack').attr("src","img/btn-back-disabled.png");
			$('#imgBack2').attr("src","img/btn-back-disabled.png");
			$('#imgBackSmall').attr("src","img/btn-back-disabled-small.png");
		}
		onChangedSlide();
	}
}


  // swipe

 $( '.carousel-inner' ).swipe( {
		swipeLeft: function( e, direction, distance, duration, count ) {
			if (ignoreMove) return;

			if (!isFrontSide) {
				$(".carousel-item.active").next(".carousel-item").find(".flippable").flip({speed: 1});
				$(".carousel-item.active").next(".carousel-item").find(".flippable").flip(false);
				$(".carousel-item.active").next(".carousel-item").find(".flippable").flip({speed: 500});
			}

			$( this ).parent().carousel( 'next' );
		},
		swipeRight: function( e, direction, distance, duration, count ) {
			if (ignoreMove) return;

			if (!isFrontSide) {
				$(".carousel-item.active").prev(".carousel-item").find(".flippable").flip({speed: 1});
				$(".carousel-item.active").prev(".carousel-item").find(".flippable").flip(false);
				$(".carousel-item.active").prev(".carousel-item").find(".flippable").flip({speed: 500});
			}

			$( this ).parent().carousel( 'prev' );
		},
		threshold: 10
 } );

 // tastiera

$(document).bind('keyup', function(e) {
	if (e.keyCode==39) {
		if (ignoreMove) return;

		if (!isFrontSide) {
			$(".carousel-item.active").next(".carousel-item").find(".flippable").flip({speed: 1});
			$(".carousel-item.active").next(".carousel-item").find(".flippable").flip(false);
			$(".carousel-item.active").next(".carousel-item").find(".flippable").flip({speed: 500});
		}

		if (doubleViewIsActive) {
			if($('#block1').css('display') == 'none'){
				$('#mobileCarousel').carousel('next');
			} else {
				$('#doubleColCarousel').carousel('next');
			}
		} else {
			if($('#block2').css('display') == 'none'){
				$('#mobileCarousel').carousel('next');
			} else {
				$('#oneColCarousel').carousel('next');
			}
		}

	}
  	else if(e.keyCode==37){
    	if (ignoreMove) return;

		if (!isFrontSide) {
			$(".carousel-item.active").prev(".carousel-item").find(".flippable").flip({speed: 1});
			$(".carousel-item.active").prev(".carousel-item").find(".flippable").flip(false);
			$(".carousel-item.active").prev(".carousel-item").find(".flippable").flip({speed: 500});
		}

		if (doubleViewIsActive) {
			if($('#block1').css('display') == 'none'){
				$('#mobileCarousel').carousel('prev');
			} else {
				$('#doubleColCarousel').carousel('prev');
			}
		} else {
			if($('#block2').css('display') == 'none'){
				$('#mobileCarousel').carousel('prev');
			} else {
				$('#oneColCarousel').carousel('prev');
			}
		}

  	}
});
